"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _react = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("react"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _constants = /*#__PURE__*/require("../../constants");
var _CustomEditor = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/CustomEditor"));
var _getCellValue = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/getCellValue"));
var _setCellTextStyleHelper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/setCellTextStyleHelper"));
var _useWatchProp = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/useWatchProp"));
var _useEventListener = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../useEventListener"));
/**
 * 获取选中区域的字体字号
 * @param state
 * @param selectedRange
 * @param initValue
 * @returns
 */
var getSelectedFontSize = function getSelectedFontSize(state, selectedRange, initValue) {
  var currentCellValue = (0, _getCellValue.default)(state, selectedRange[0][0], selectedRange[0][1]);
  var isAllHasStyle = currentCellValue.every(function (element) {
    return element.children.every(function (textItem) {
      return textItem.fontSize;
    });
  });
  return isAllHasStyle ? currentCellValue[0].children[0].fontSize : initValue;
};
var FONT_SIZE_ITEMS = [12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72];
/**
 * 字号选择按钮组件
 * @param props
 * @returns
 */
function FontSizeSelectButton(props) {
  var _props$editor = props.editor,
    editor = _props$editor === void 0 ? {} : _props$editor,
    selectedRange = props.selectedRange,
    editingCell = props.editingCell;
  var initValue = '16';
  var _useState = (0, _react.useState)(initValue),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var dispatch = (0, _reactRedux.useDispatch)();
  var state = (0, _reactRedux.useStore)().getState().present;
  var rows = (0, _reactRedux.useSelector)(function (reduxState) {
    return reduxState.present.rows;
  });
  var merges = (0, _reactRedux.useSelector)(function (reduxState) {
    return reduxState.present.merges;
  });
  (0, _useWatchProp.default)(selectedRange, function () {
    if (selectedRange) {
      setValue(getSelectedFontSize(state, selectedRange, initValue));
    }
  });
  (0, _useEventListener.default)(_constants.eventbus, _constants.EDITOR_CHANGE, function (currentEditor) {
    var _CustomEditor$getFont;
    setValue((_CustomEditor$getFont = _CustomEditor.default.getFontSize(currentEditor)) !== null && _CustomEditor$getFont !== void 0 ? _CustomEditor$getFont : initValue);
  });
  var handleChange = function handleChange(event) {
    setValue(event.target.value);
    (0, _setCellTextStyleHelper.default)(editor, dispatch, 'fontSize', event.target.value, rows, merges, selectedRange, editingCell);
  };
  return (0, _jsxRuntime.jsx)("select", {
    value: value,
    onChange: handleChange,
    children: FONT_SIZE_ITEMS.map(function (size) {
      return (0, _jsxRuntime.jsx)("option", {
        value: size,
        children: size
      }, size);
    })
  });
}
var _default = /*#__PURE__*/_react.default.memo(FontSizeSelectButton);
exports.default = _default;