import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import Button from '@sinoui/core/Button';
import DialogActions from '@sinoui/core/DialogActions';
import DialogContent from '@sinoui/core/DialogContent';
import DialogTitle from '@sinoui/core/DialogTitle';
import { Column, Row } from '@sinoui/core/Grid';
import InputAdornment from '@sinoui/core/InputAdornment';
import Radio from '@sinoui/core/Radio';
import RadioGroup from '@sinoui/core/RadioGroup';
import Select, { Option } from '@sinoui/core/Select';
import TextInput from '@sinoui/core/TextInput';
import { Form, FormItem } from '@sinoui/rx-core-form';
import styled from 'styled-components';
import { PAGE_SIZES } from '../../constants';
const Seporate = styled(Row) `
  border-bottom: 1px solid ${({ theme }) => theme.palette.text.disabled};
  margin-bottom: 8px;
  color: ${({ theme }) => theme.palette.text.primary};
`;
/**
 * 打印设置表单
 *
 * @param param0
 * @param props
 * @returns
 */
export default function PrintConfigPanel(props) {
    const { formState, onOk, onClose } = props;
    return (_jsxs(_Fragment, { children: [_jsx(DialogTitle, { children: "\u6253\u5370\u8BBE\u7F6E" }), _jsx(DialogContent, { children: _jsxs(Form, { formState: formState, dense: true, variant: "outlined", children: [_jsx(Seporate, { children: "\u9875\u9762\u8BBE\u7F6E" }), _jsx(Row, { children: _jsx(Column, { children: _jsx(FormItem, { name: "pageConfig.pageSize", label: "\u7EB8\u5F20\u5927\u5C0F", children: _jsx(Select, { allowClear: false, children: PAGE_SIZES.map((size) => (_jsx(Option, { value: size, children: size }, size))) }) }) }) }), _jsx(Row, { children: _jsx(Column, { children: _jsx(FormItem, { name: "pageConfig.pageDir", label: "\u7EB8\u5F20\u65B9\u5411", children: _jsxs(Select, { allowClear: false, children: [_jsx(Option, { value: "\u7EB5\u5411", children: "\u7EB5\u5411" }), _jsx(Option, { value: "\u6A2A\u5411", children: "\u6A2A\u5411" })] }) }) }) }), _jsxs(Row, { gutter: 16, gutterType: "between", children: [_jsx(Column, { xs: 12, children: _jsx(FormItem, { name: "pageConfig.pagePaddingTop", label: "\u4E0A\u8FB9\u8DDD", children: _jsx(TextInput, { endAdornment: _jsx(InputAdornment, { position: "end", children: "mm" }) }) }) }), _jsx(Column, { xs: 12, children: _jsx(FormItem, { name: "pageConfig.pagePaddingBottom", label: "\u4E0B\u8FB9\u8DDD", children: _jsx(TextInput, { endAdornment: _jsx(InputAdornment, { position: "end", children: "mm" }) }) }) }), _jsx(Column, { xs: 12, children: _jsx(FormItem, { name: "pageConfig.pagePaddingLeft", label: "\u5DE6\u8FB9\u8DDD", children: _jsx(TextInput, { endAdornment: _jsx(InputAdornment, { position: "end", children: "mm" }) }) }) }), _jsx(Column, { xs: 12, children: _jsx(FormItem, { name: "pageConfig.pagePaddingRight", label: "\u53F3\u8FB9\u8DDD", children: _jsx(TextInput, { endAdornment: _jsx(InputAdornment, { position: "end", children: "mm" }) }) }) })] }), _jsx(Seporate, { children: "\u5185\u5BB9\u8BBE\u7F6E" }), _jsxs(Row, { gutter: 16, gutterType: "between", children: [_jsx(Column, { xs: 12, children: _jsx(FormItem, { name: "contentConfig.isShowDefaultTitle", label: "\u662F\u5426\u663E\u793A\u9ED8\u8BA4\u7684\u8868\u5355\u6807\u9898", children: _jsxs(RadioGroup, { children: [_jsx(Radio, { value: "1", children: "\u662F" }), _jsx(Radio, { value: "0", children: "\u5426" })] }) }) }), _jsx(Column, { xs: 12, children: _jsx(FormItem, { name: "contentConfig.isAutoHeight", label: "\u884C\u9AD8\u662F\u5426\u6839\u636E\u5185\u5BB9\u81EA\u52A8\u8BA1\u7B97", children: _jsxs(RadioGroup, { children: [_jsx(Radio, { value: "1", children: "\u662F" }), _jsx(Radio, { value: "0", children: "\u5426" })] }) }) })] })] }) }), _jsxs(DialogActions, { children: [_jsx(Button, { onClick: onClose, children: "\u53D6\u6D88" }), _jsx(Button, { raised: true, onClick: onOk, children: "\u786E\u5B9A" })] })] }));
}
