import { jsx as _jsx } from "react/jsx-runtime";
import classNames from 'classnames';
// eslint-disable-next-line import/no-extraneous-dependencies
import styled from 'styled-components';
const getClassName = (leaf) => leaf.type;
const Wrapper = styled.span `
  ${({ $error }) => $error &&
    `
    position: relative;
    
    &::after {
      content: '';
      position: absolute;
      left:0;
      bottom:0;
      width: 100%;
      height: 0.25em;

      background:
          linear-gradient(135deg, transparent, transparent 45%, red, transparent 55%, transparent 100%),
          linear-gradient(45deg, transparent, transparent 45%, red, transparent 55%, transparent 100%);
      background-size: 0.25em 0.5em;
      background-repeat: repeat-x, repeat-x;
    }
`}

  ${({ $color }) => $color && `color: rgba(${$color.r}, ${$color.g}, ${$color.b}, ${$color.a})`}
`;
/**
 * 带格式文本渲染组件
 *
 * @param props
 * @returns
 */
export default function Leaf(props) {
    const { leaf, attributes, children } = props;
    const { color } = leaf;
    return (_jsx(Wrapper, { ...attributes, className: classNames('token', getClassName(leaf)), style: {
            fontWeight: leaf.bold ? 'bold' : 'normal',
            fontStyle: leaf.italic ? 'italic' : 'normal',
            textDecoration: leaf.underLine ? 'underline' : 'none',
            fontSize: leaf.fontSize ? parseInt(leaf.fontSize, 10) : 'normal',
            fontFamily: leaf.fontFamily ? leaf.fontFamily : 'inherit',
        }, "$error": leaf.error, "$color": color, title: leaf.title, children: leaf.deleteLine ? _jsx("s", { children: children }) : children }));
}
