import { isEqual } from 'lodash';
import getAllCellsInRange from './getAllCellsInRange';
import getAllInMergedCells from './getAllInMergedCells';
/**
 * 获取选中范围内所有单元格
 * @param selectedRange 选中范围
 * @returns
 */
export default function getAllSelectedCells(selectedRange, merges = []) {
    const cellsInRange = getAllCellsInRange(selectedRange);
    const cellsInMerge = getAllInMergedCells(merges);
    return cellsInRange.filter((cell) => cellsInMerge.findIndex((item) => isEqual(item, cell)) === -1);
}
