import { findAllCodes } from '@sinoform/print-out-core';
import isCodeType from './isCodeType';
/**
 * 获取指定位置的节点信息
 * @param editor
 * @param point
 * @returns
 */
export default function getNodeInfoByPoint(editor, point) {
    const { children } = editor;
    const row = point.path[0];
    const col = point.path[1];
    const currentNode = children[row].children[col];
    if (isCodeType(editor, point)) {
        const codeBlocks = findAllCodes(currentNode.text);
        return codeBlocks.find((block) => point.offset >= block.start && point.offset <= block.end);
    }
    return currentNode;
}
