"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _react = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("react"));
var _FormatBold = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/FormatBold"));
var _reactRedux = /*#__PURE__*/require("react-redux");
var _setCellTextStyleHelper = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/setCellTextStyleHelper"));
var _CustomEditor = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/CustomEditor"));
var _DenseIconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./DenseIconButton"));
var _useSingleStyleState = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./useSingleStyleState"));
/**
 * 字体加粗按钮
 */
function FormatBoldButton(_ref) {
  var _ref$editor = _ref.editor,
    editor = _ref$editor === void 0 ? {} : _ref$editor,
    selectedRange = _ref.selectedRange,
    editingCell = _ref.editingCell;
  var dispatch = (0, _reactRedux.useDispatch)();
  var rows = (0, _reactRedux.useSelector)(function (state) {
    return state.present.rows;
  });
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  var _useSingleStyleActive = (0, _useSingleStyleState.default)('bold', selectedRange, _CustomEditor.default.isBoldMarkActive),
    _useSingleStyleActive2 = (0, _slicedToArray2.default)(_useSingleStyleActive, 2),
    isBold = _useSingleStyleActive2[0],
    setIsBold = _useSingleStyleActive2[1];
  var handleMouseDown = function handleMouseDown(event) {
    event.preventDefault();
    if (!editingCell) {
      setIsBold(!isBold);
    }
    (0, _setCellTextStyleHelper.default)(editor, dispatch, 'bold', '', rows, merges, selectedRange, editingCell);
  };
  return (0, _jsxRuntime.jsx)(_DenseIconButton.default, {
    dense: true,
    onMouseDown: handleMouseDown,
    isActive: isBold,
    children: (0, _jsxRuntime.jsx)(_FormatBold.default, {})
  });
}
var _default = /*#__PURE__*/_react.default.memo(FormatBoldButton);
exports.default = _default;