"use strict";

var _interopRequireWildcard = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = HorizontalSelectButton;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _IconButton = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/core/IconButton"));
var _Menu = /*#__PURE__*/_interopRequireWildcard( /*#__PURE__*/require("@sinoui/core/Menu"));
var _FormatAlignCenter = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/FormatAlignCenter"));
var _FormatAlignLeft = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/FormatAlignLeft"));
var _FormatAlignRight = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoui/icons/FormatAlignRight"));
var _react = /*#__PURE__*/require("react");
var _reactRedux = /*#__PURE__*/require("react-redux");
var _reducer = /*#__PURE__*/require("../../reducer");
var _getAllSelectedCells = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../../utils/getAllSelectedCells"));
function HorizontalSelectButton(_ref) {
  var selectedRange = _ref.selectedRange,
    disabled = _ref.disabled;
  var _useState = (0, _react.useState)('left'),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    open = _useState4[0],
    setOpen = _useState4[1];
  var anchorEl = (0, _react.useRef)(null);
  var dispatch = (0, _reactRedux.useDispatch)();
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  var handleClick = function handleClick(val) {
    setValue(val);
    setOpen(false);
    if (!selectedRange) return;
    var cells = (0, _getAllSelectedCells.default)(selectedRange, merges);
    dispatch((0, _reducer.setCellsStyle)(cells, {
      horizontal: val
    }));
  };
  var render = function render() {
    if (value === 'right') {
      return (0, _jsxRuntime.jsx)(_FormatAlignRight.default, {});
    }
    if (value === 'center') {
      return (0, _jsxRuntime.jsx)(_FormatAlignCenter.default, {});
    }
    return (0, _jsxRuntime.jsx)(_FormatAlignLeft.default, {});
  };
  return (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(0, _jsxRuntime.jsx)(_IconButton.default, {
      disabled: disabled,
      style: {
        borderRadius: 0
      },
      dense: true,
      onClick: function onClick() {
        return setOpen(true);
      },
      ref: anchorEl,
      children: render()
    }), (0, _jsxRuntime.jsxs)(_Menu.default, {
      dense: true,
      open: open,
      referenceElement: anchorEl,
      onRequestClose: function onRequestClose() {
        return setOpen(false);
      },
      children: [(0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleClick('left');
        },
        children: (0, _jsxRuntime.jsx)(_FormatAlignLeft.default, {})
      }), (0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleClick('center');
        },
        children: (0, _jsxRuntime.jsx)(_FormatAlignCenter.default, {})
      }), (0, _jsxRuntime.jsx)(_Menu.MenuListItem, {
        onClick: function onClick() {
          return handleClick('right');
        },
        children: (0, _jsxRuntime.jsx)(_FormatAlignRight.default, {})
      })]
    })]
  });
}