"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Leaf;
var _objectSpread2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectSpread2"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _classnames = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("classnames"));
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
// eslint-disable-next-line import/no-extraneous-dependencies

var getClassName = function getClassName(leaf) {
  return leaf.type;
};
var Wrapper = /*#__PURE__*/_styledComponents.default.span.withConfig({
  displayName: "Leaf__Wrapper",
  componentId: "sc-y95pkm-0"
})(["", " ", ""], function (_ref) {
  var $error = _ref.$error;
  return $error && "\n    position: relative;\n    \n    &::after {\n      content: '';\n      position: absolute;\n      left:0;\n      bottom:0;\n      width: 100%;\n      height: 0.25em;\n\n      background:\n          linear-gradient(135deg, transparent, transparent 45%, red, transparent 55%, transparent 100%),\n          linear-gradient(45deg, transparent, transparent 45%, red, transparent 55%, transparent 100%);\n      background-size: 0.25em 0.5em;\n      background-repeat: repeat-x, repeat-x;\n    }\n";
}, function (_ref2) {
  var $color = _ref2.$color;
  return $color && "color: rgba(".concat($color.r, ", ").concat($color.g, ", ").concat($color.b, ", ").concat($color.a, ")");
});
/**
 * 带格式文本渲染组件
 *
 * @param props
 * @returns
 */
function Leaf(props) {
  var leaf = props.leaf,
    attributes = props.attributes,
    children = props.children;
  var color = leaf.color;
  return (0, _jsxRuntime.jsx)(Wrapper, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, attributes), {}, {
    className: (0, _classnames.default)('token', getClassName(leaf)),
    style: {
      fontWeight: leaf.bold ? 'bold' : 'normal',
      fontStyle: leaf.italic ? 'italic' : 'normal',
      textDecoration: leaf.underLine ? 'underline' : 'none',
      fontSize: leaf.fontSize ? parseInt(leaf.fontSize, 10) : 'normal',
      fontFamily: leaf.fontFamily ? leaf.fontFamily : 'inherit'
    },
    "$error": leaf.error,
    "$color": color,
    title: leaf.title,
    children: leaf.deleteLine ? (0, _jsxRuntime.jsx)("s", {
      children: children
    }) : children
  }));
}