"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _jsxRuntime = /*#__PURE__*/require("react/jsx-runtime");
var _react = /*#__PURE__*/require("react");
var _reactRedux = /*#__PURE__*/require("react-redux");
var _styledComponents = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("styled-components"));
var _constants = /*#__PURE__*/require("../constants");
var _reducer = /*#__PURE__*/require("../reducer");
var _drawRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./drawRange"));
var Wrapper = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "ContextMenu__Wrapper",
  componentId: "sc-saqbuw-0"
})(["position:fixed;background:white;box-shadow:0px 2px 10px #999999;z-index:100;"]);
var MenuItem = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "ContextMenu__MenuItem",
  componentId: "sc-saqbuw-1"
})(["padding:8px 10px;width:", "px;cursor:default;font-family:'Helvetica Neue','PingFang SC','Hiragino Sans GB','Microsoft YaHei',Arial,sans-serif;font-size:12px;cursor:pointer;&:hover{background:#eee;}"], _constants.DEFAULT_MENU_WIDTH);
var Devider = /*#__PURE__*/_styledComponents.default.div.withConfig({
  displayName: "ContextMenu__Devider",
  componentId: "sc-saqbuw-2"
})(["width:100%;height:1px;border:none;margin:1px;background:#ddd;"]);
function ContextMenu(_ref) {
  var pos = _ref.pos,
    contextMenuShow = _ref.contextMenuShow,
    setContextMenuShow = _ref.setContextMenuShow,
    selectedRange = _ref.selectedRange,
    copyOrCut = _ref.copyOrCut,
    setCopyOrCut = _ref.setCopyOrCut,
    cellRangeForCopyOrCut = _ref.cellRangeForCopyOrCut,
    setCellRangeForCopyOrCut = _ref.setCellRangeForCopyOrCut,
    setSelectedRange = _ref.setSelectedRange;
  var dispatch = (0, _reactRedux.useDispatch)();
  var merges = (0, _reactRedux.useSelector)(function (state) {
    return state.present.merges;
  });
  if (!contextMenuShow || !pos) {
    return null;
  }
  var handleRowInsert = function handleRowInsert() {
    if (!selectedRange) {
      return;
    }
    dispatch((0, _reducer.insertRow)(selectedRange[0][0]));
    setContextMenuShow(false);
  };
  var handleColInsert = function handleColInsert() {
    if (!selectedRange) return;
    dispatch((0, _reducer.insertCol)(selectedRange[0][1]));
    setContextMenuShow(false);
  };
  var handleRowDelete = function handleRowDelete() {
    if (!selectedRange) return;
    dispatch((0, _reducer.deleteRow)(selectedRange[0][0], selectedRange[1][0] - selectedRange[0][0] + 1));
    setContextMenuShow(false);
  };
  var handleColDelete = function handleColDelete() {
    if (!selectedRange) return;
    dispatch((0, _reducer.deleteCol)(selectedRange[0][1], selectedRange[1][1]));
    setContextMenuShow(false);
  };
  var handleCopyOrCutCell = function handleCopyOrCutCell(type) {
    if (!selectedRange) return;
    setCopyOrCut(type);
    setCellRangeForCopyOrCut(selectedRange);
    setContextMenuShow(false);
  };
  var handlePasteCell = function handlePasteCell() {
    var _merges$find$, _merges$find;
    if (!cellRangeForCopyOrCut || !selectedRange) {
      return;
    }
    if (copyOrCut === 'copy') {
      dispatch((0, _reducer.copyCell)(cellRangeForCopyOrCut, selectedRange[0]));
    } else if (copyOrCut === 'cut') {
      dispatch((0, _reducer.cutCell)(cellRangeForCopyOrCut, selectedRange[0]));
    }
    var endPos = [selectedRange[0][0] + cellRangeForCopyOrCut[1][0] - cellRangeForCopyOrCut[0][0], selectedRange[0][1] + cellRangeForCopyOrCut[1][1] - cellRangeForCopyOrCut[0][1]];
    endPos = (_merges$find$ = merges === null || merges === void 0 ? void 0 : (_merges$find = merges.find(function (_ref2) {
      var _ref3 = (0, _slicedToArray2.default)(_ref2, 2),
        _ref3$ = (0, _slicedToArray2.default)(_ref3[0], 2),
        sri = _ref3$[0],
        sci = _ref3$[1],
        _ref3$2 = (0, _slicedToArray2.default)(_ref3[1], 2),
        eri = _ref3$2[0],
        eci = _ref3$2[1];
      return sri <= endPos[0] && endPos[0] <= eri && sci <= endPos[1] && endPos[1] <= eci;
    })) === null || _merges$find === void 0 ? void 0 : _merges$find[0]) !== null && _merges$find$ !== void 0 ? _merges$find$ : endPos;
    (0, _drawRange.default)(selectedRange[0], endPos);
    setSelectedRange([selectedRange[0], endPos]);
    setContextMenuShow(false);
  };
  return (0, _jsxRuntime.jsxs)(Wrapper, {
    style: {
      left: "".concat(pos[0], "px"),
      top: "".concat(pos[1], "px")
    },
    children: [(0, _jsxRuntime.jsx)(MenuItem, {
      onClick: function onClick() {
        return handleCopyOrCutCell('copy');
      },
      children: "\u590D\u5236"
    }), (0, _jsxRuntime.jsx)(MenuItem, {
      onClick: function onClick() {
        return handleCopyOrCutCell('cut');
      },
      children: "\u526A\u5207"
    }), (0, _jsxRuntime.jsx)(MenuItem, {
      onClick: handlePasteCell,
      children: "\u7C98\u8D34"
    }), (0, _jsxRuntime.jsx)(Devider, {}), (0, _jsxRuntime.jsx)(MenuItem, {
      onClick: handleRowInsert,
      children: "\u63D2\u5165\u884C"
    }), (0, _jsxRuntime.jsx)(MenuItem, {
      onClick: handleColInsert,
      children: "\u63D2\u5165\u5217"
    }), (0, _jsxRuntime.jsx)(MenuItem, {
      onClick: handleRowDelete,
      children: "\u5220\u9664\u884C"
    }), (0, _jsxRuntime.jsx)(MenuItem, {
      onClick: handleColDelete,
      children: "\u5220\u9664\u5217"
    })]
  });
}
var _default = /*#__PURE__*/(0, _react.memo)(ContextMenu);
exports.default = _default;