"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = drawRange;
/**
 * 绘制选中区域
 * @param startPos 开始单元格位置
 * @param endPos 结束单元格位置
 * @returns
 */
function drawRange(startPos, endPos) {
  var selectRange = document.querySelector('.sinoui-table-select-range');
  var startCell = document.getElementById("".concat(startPos[0], "-").concat(startPos[1]));
  var endCell = document.getElementById("".concat(endPos[0], "-").concat(endPos[1]));
  // 开始或结束的单元格不存在说明单元格是被合并的，改为使用表头或列头的单元格位置进行计算
  if (!startCell) {
    var startRowHeader = document.getElementById("table-row-header-".concat(startPos[0]));
    var startColHeader = document.getElementById("table-col-header-".concat(startPos[1]));
    startCell = {
      offsetLeft: startColHeader.offsetLeft,
      offsetTop: startRowHeader.offsetTop
    };
  }
  if (!endCell) {
    var endRowHeader = document.getElementById("table-row-header-".concat(endPos[0]));
    var endColHeader = document.getElementById("table-col-header-".concat(endPos[1]));
    endCell = {
      offsetLeft: endColHeader.offsetLeft,
      offsetTop: endRowHeader.offsetTop,
      offsetWidth: endColHeader.offsetWidth,
      offsetHeight: endRowHeader.offsetHeight
    };
  }
  var width = endCell.offsetLeft + endCell.offsetWidth - startCell.offsetLeft;
  var height = endCell.offsetTop + endCell.offsetHeight - startCell.offsetTop;
  selectRange.style.display = 'block';
  selectRange.style.width = "".concat(width, "px");
  selectRange.style.height = "".concat(height, "px");
  selectRange.style.left = "".concat(startCell.offsetLeft, "px");
  selectRange.style.top = "".concat(startCell.offsetTop, "px");
}