import { Cell, CustomPrintConfig } from '@sinoform/types';
import { ReduxPrintConfig } from '../reducer';
/**
 * 判断一个单元格是否被合并，用于单元格渲染时的判断条件
 * 如果被合并返回true，将不再被渲染
 * 需要注意的是，合并单元格第一个位置上的单元格因为需要被渲染，所以返回false
 * @param rowIdx  单元格所在行
 * @param colIdx  单元格所在列
 * @param merges  所有的合并单元格信息
 * @returns
 */
declare const checkTdIsMerged: (rowIdx: number, colIdx: number, merges?: [
    [
        number,
        number
    ],
    [
        number,
        number
    ]
][]) => boolean;
/**
 * 转换单元格的边框样式
 * @param border
 * @returns
 */
declare const getCellBorderStyle: (border?: {
    [x: string]: [string, string];
}) => {
    [x: string]: string;
};
/**
 * 根据打印配置获取对应的标尺线位置
 * @param page 页面配置信息
 * @param type 水平线或垂直线
 * @returns
 */
declare const transformCMToPxByConfig: (page: ReduxPrintConfig, type?: 'h' | 'v') => number;
/**
 * 获取单元格的高度
 * @param state
 * @param rowIdx
 * @param cell
 * @returns
 */
declare const getCellHeight: (state: CustomPrintConfig, rowIdx: number, cell: Cell) => number;
/**
 * 获取单元格宽度
 * @param state
 * @param colIdx
 * @param cell
 * @returns
 */
declare const getCellWidth: (state: CustomPrintConfig, colIdx: number, cell: Cell) => number;
export { checkTdIsMerged, getCellBorderStyle, transformCMToPxByConfig, getCellHeight, getCellWidth, };
