import type { EditorToken } from '@sinoform/helper-formula-analysis';
import type { LayoutFieldItem } from '@sinoform/types';
import type { CellPos, State } from '../types';
export declare function getAllSubFieldFromToken(tokens: EditorToken[], fields: LayoutFieldItem[]): Set<string>;
/**
 * 获取当前行所有单元格公式的token信息
 *
 * @param draft   状态
 * @param cellPos 单元格位置
 * @param value   表达式
 */
export declare function getAllCodeTokensInRow(draft: State, cellPos: CellPos, value: any): any[];
/**
 * 同一行单元格的表达式中不能出现不同子表单的表单项
 * 表达式中出现了子表单选项一律视为表单项的值，不考虑其作为打印值的场景
 *
 * @param draft     状态
 * @param cellPos   单元格位置
 * @param value     表达式的值
 * @param fields    表单项集合
 */
export default function checkSubFieldInRow(draft: State, cellPos: CellPos, value: any, fields?: LayoutFieldItem[]): boolean;
