"use strict";

var _interopRequireDefault = /*#__PURE__*/require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultState = exports.default = void 0;
var _defineProperty2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/defineProperty"));
var _toConsumableArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/toConsumableArray"));
var _objectSpread3 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/objectSpread2"));
var _createForOfIteratorHelper2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/createForOfIteratorHelper"));
var _slicedToArray2 = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@babel/runtime/helpers/slicedToArray"));
var _globalUi = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("@sinoform/global-ui"));
var _types = /*#__PURE__*/require("@sinoform/types");
var _immer = /*#__PURE__*/require("immer");
var _constants = /*#__PURE__*/require("../constants");
var _getAllSelectedCells = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("../utils/getAllSelectedCells"));
var _checkCellRange = /*#__PURE__*/require("./helper/checkCellRange");
var _getCellValueInRange = /*#__PURE__*/_interopRequireDefault( /*#__PURE__*/require("./helper/getCellValueInRange"));
var _types2 = /*#__PURE__*/require("./types");
var defaultState = {
  cols: {
    len: 10
  },
  rows: {
    len: 80
  },
  config: {
    pageConfig: {
      pageDir: _types.PageDirType.VERTICAL,
      pageSize: _types.PageSizeType.A4,
      pagePaddingTop: '25.5',
      pagePaddingBottom: '25.5',
      pagePaddingLeft: '23.7',
      pagePaddingRight: '23.7'
    },
    contentConfig: {
      isAutoHeight: '0',
      isShowDefaultTitle: '0'
    }
  }
};
/**
 * 合并或拆分单元格
 *
 * @param draft
 * @param action
 */
exports.defaultState = defaultState;
var mergeCells = function mergeCells(draft, action) {
  var _draft$merges;
  var _action$payload = action.payload,
    fromCell = _action$payload.fromCell,
    toCell = _action$payload.toCell;
  // 判断起始和结束范围内的单元格有没有被合并的单元格，如果存在执行拆分动作，否则执行合并动作
  var cells = ((_draft$merges = draft.merges) !== null && _draft$merges !== void 0 ? _draft$merges : []).filter(function (_ref) {
    var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
      _ref2$ = (0, _slicedToArray2.default)(_ref2[0], 2),
      sri = _ref2$[0],
      sci = _ref2$[1],
      _ref2$2 = (0, _slicedToArray2.default)(_ref2[1], 2),
      eri = _ref2$2[0],
      eci = _ref2$2[1];
    return sri >= fromCell[0] && sci >= fromCell[1] && eri <= toCell[0] && eci <= toCell[1];
  });
  if (cells.length > 0) {
    var _draft$merges2;
    draft.merges = (_draft$merges2 = draft.merges) === null || _draft$merges2 === void 0 ? void 0 : _draft$merges2.filter(function (_ref3) {
      var _ref4 = (0, _slicedToArray2.default)(_ref3, 2),
        _ref4$ = (0, _slicedToArray2.default)(_ref4[0], 2),
        sri = _ref4$[0],
        sci = _ref4$[1],
        _ref4$2 = (0, _slicedToArray2.default)(_ref4[1], 2),
        eri = _ref4$2[0],
        eci = _ref4$2[1];
      return !(sri >= fromCell[0] && sci >= fromCell[1] && eri <= toCell[0] && eci <= toCell[1]);
    });
    // eslint-disable-next-line no-restricted-syntax
    var _iterator = (0, _createForOfIteratorHelper2.default)(cells),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _draft$rows$cell$0$, _draft$rows$cell$0$$c;
        var cell = _step.value;
        if ((_draft$rows$cell$0$ = draft.rows[cell[0][0]]) !== null && _draft$rows$cell$0$ !== void 0 && (_draft$rows$cell$0$$c = _draft$rows$cell$0$.cells) !== null && _draft$rows$cell$0$$c !== void 0 && _draft$rows$cell$0$$c[cell[0][1]]) {
          delete draft.rows[cell[0][0]].cells[cell[0][1]].merge;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  } else {
    var _draft$merges3;
    draft.merges = (_draft$merges3 = draft.merges) !== null && _draft$merges3 !== void 0 ? _draft$merges3 : [];
    draft.merges.push([fromCell, toCell]);
    var cellValues = (0, _getCellValueInRange.default)([fromCell, toCell], draft);
    for (var i = fromCell[0]; i <= toCell[0]; i += 1) {
      for (var j = fromCell[1]; j <= toCell[1]; j += 1) {
        var _draft$rows, _draft$rows$i2, _draft$rows$i2$cells;
        if (i === fromCell[0] && j === fromCell[1]) {
          var _draft$rows$i, _draft$rows$i$cells, _draft$rows$i$cells$j, _draft$rows$i$cells2;
          draft.rows[i] = (_draft$rows$i = draft.rows[i]) !== null && _draft$rows$i !== void 0 ? _draft$rows$i : {
            cells: {}
          };
          draft.rows[i].cells = (_draft$rows$i$cells = draft.rows[i].cells) !== null && _draft$rows$i$cells !== void 0 ? _draft$rows$i$cells : {};
          draft.rows[i].cells[j] = (_draft$rows$i$cells$j = (_draft$rows$i$cells2 = draft.rows[i].cells) === null || _draft$rows$i$cells2 === void 0 ? void 0 : _draft$rows$i$cells2[j]) !== null && _draft$rows$i$cells$j !== void 0 ? _draft$rows$i$cells$j : {};
          draft.rows[i].cells[j].merge = [toCell[0] - fromCell[0], toCell[1] - fromCell[1]];
          // 如果选中区域只有一个有效值，直接使用该值，否则使用左上角单元格的值
          draft.rows[i].cells[j].value = cellValues.length === 1 ? cellValues[0] : draft.rows[i].cells[j].value;
        } else if ((_draft$rows = draft.rows) !== null && _draft$rows !== void 0 && (_draft$rows$i2 = _draft$rows[i]) !== null && _draft$rows$i2 !== void 0 && (_draft$rows$i2$cells = _draft$rows$i2.cells) !== null && _draft$rows$i2$cells !== void 0 && _draft$rows$i2$cells[j]) {
          delete draft.rows[i].cells[j];
        }
      }
    }
  }
};
/**
 * 改变行高
 *
 * @param draft
 * @param action
 */
var changeRowHeight = function changeRowHeight(draft, action) {
  var _draft$rows$rowIdx;
  var _action$payload2 = action.payload,
    rowIdx = _action$payload2.rowIdx,
    height = _action$payload2.height;
  draft.rows[rowIdx] = (_draft$rows$rowIdx = draft.rows[rowIdx]) !== null && _draft$rows$rowIdx !== void 0 ? _draft$rows$rowIdx : {};
  draft.rows[rowIdx].height = height;
};
/*
 * 插入行
 * @param draft
 * @param action
 */
var insertRow = function insertRow(draft, action) {
  var _draft$merges4;
  var payload = action.payload;
  draft.rows.len += 1;
  // 处理单元格的合并信息
  ((_draft$merges4 = draft.merges) !== null && _draft$merges4 !== void 0 ? _draft$merges4 : []).forEach(function (merge, idx) {
    var _merge = (0, _slicedToArray2.default)(merge, 2),
      _merge$ = (0, _slicedToArray2.default)(_merge[0], 2),
      sri = _merge$[0],
      sci = _merge$[1],
      _merge$2 = (0, _slicedToArray2.default)(_merge[1], 2),
      tri = _merge$2[0],
      tci = _merge$2[1];
    // 如果插入行横穿合并的单元格，则合并结束单元格索引增加1
    if (sri < payload && tri >= payload) {
      draft.rows[sri].cells[sci] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[sri].cells[sci]), {}, {
        merge: [draft.rows[sri].cells[sci].merge[0] + 1, draft.rows[sri].cells[sci].merge[1]]
      });
      draft.merges[idx] = [merge[0], [tri + 1, tci]];
    }
    // 如果合并单元格在插入位置之后，则合并单元格的起始行和结束行索引均增加1
    if (sri >= payload) {
      draft.merges[idx] = [[sri + 1, sci], [tri + 1, tci]];
    }
  });
  var newRows = {
    len: draft.rows.len
  };
  // 处理每行的单元格数据
  Object.entries(draft.rows).filter(function (item) {
    return item[0] !== 'len';
  }).forEach(function (_ref5) {
    var _ref6 = (0, _slicedToArray2.default)(_ref5, 2),
      rowIdx = _ref6[0],
      row = _ref6[1];
    var currentRowIdx = parseInt(rowIdx, 10);
    if (currentRowIdx < payload) {
      // 如果当前行在插入行之前，则不做处理，否则行索引增加1
      newRows[currentRowIdx] = row;
    } else {
      newRows[currentRowIdx + 1] = row;
    }
  });
  draft.rows = newRows;
};
/**
 * 从制定位置删除指定行数
 *
 * @param draft 状态数据
 * @param action 动作
 */
var deleteRow = function deleteRow(draft, action) {
  var _draft$merges5, _draft$merges6;
  var _action$payload3 = action.payload,
    from = _action$payload3.from,
    len = _action$payload3.len;
  var end = from + len - 1;
  // 处理总行数
  draft.rows.len -= len;
  var formRowCells = {};
  // 处理单元格合并集合数据
  ((_draft$merges5 = draft.merges) !== null && _draft$merges5 !== void 0 ? _draft$merges5 : []).forEach(function (merge, idx) {
    var _merge2 = (0, _slicedToArray2.default)(merge, 2),
      _merge2$ = (0, _slicedToArray2.default)(_merge2[0], 2),
      sri = _merge2$[0],
      sci = _merge2$[1],
      _merge2$2 = (0, _slicedToArray2.default)(_merge2[1], 2),
      tri = _merge2$2[0],
      tci = _merge2$2[1];
    // 合并的单元格整个在删除区域内,删除此单元格及单元格对应的合并数据
    if (sri >= from && tri <= end) {
      delete draft.rows[sri].cells[sci];
      delete draft.merges[idx];
    }
    // 合并的单元格的起始行在删除区域内，但结束行不在
    if (sri >= from && sri <= end && tri > end) {
      formRowCells[sci] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[sri].cells[sci]), {}, {
        value: undefined,
        merge: [draft.rows[sri].cells[sci].merge[0] - (end - sri + 1), draft.rows[sri].cells[sci].merge[1]]
      });
      draft.merges[idx] = [[from, sci], [tri - len, tci]];
    }
    // 合并的单元格的起始行不在删除区域，但结束行在删除区域
    if (sri < from && tri >= from && tri < end) {
      draft.rows[sri].cells[sci] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[sri].cells[sci]), {}, {
        merge: [draft.rows[sri].cells[sci].merge[0] - (tri - from + 1), draft.rows[sri].cells[sci].merge[1]]
      });
      draft.merges[idx] = [[sri, sci], [from - 1, tci]];
    }
    // 合并单元格在删除行之后的行
    if (sri > end) {
      draft.merges[idx] = [[sri - len, sci], [tri - len, tci]];
    }
    // 如果删除区域横穿合并区域，则只需把合并结束行索引减去删除的长度即可
    if (sri < from && tri >= end) {
      draft.rows[sri].cells[sci] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[sri].cells[sci]), {}, {
        merge: [draft.rows[sri].cells[sci].merge[0] - len, draft.rows[sri].cells[sci].merge[1]]
      });
      draft.merges[idx] = [[sri, sci], [tri - len, tci]];
    }
  });
  draft.merges = (_draft$merges6 = draft.merges) === null || _draft$merges6 === void 0 ? void 0 : _draft$merges6.filter(Boolean);
  var newRows = {
    len: draft.rows.len
  };
  // 处理每行的单元格数据
  Object.entries(draft.rows).filter(function (item) {
    return item[0] !== 'len';
  }).forEach(function (_ref7) {
    var _ref8 = (0, _slicedToArray2.default)(_ref7, 2),
      rowIdx = _ref8[0],
      row = _ref8[1];
    var currentRowIdx = parseInt(rowIdx, 10);
    if (currentRowIdx < from) {
      newRows[currentRowIdx] = row;
    } else if (currentRowIdx > end) {
      newRows[currentRowIdx - len] = row;
    }
  });
  if (Object.keys(formRowCells).length > 0) {
    var _newRows$from;
    newRows[from] = (_newRows$from = newRows[from]) !== null && _newRows$from !== void 0 ? _newRows$from : {
      cells: {}
    };
    Object.assign(newRows[from].cells, formRowCells);
  }
  draft.rows = newRows;
};
/**
 * 改变列宽
 *
 * @param draft
 * @param action
 */
var changeColWidth = function changeColWidth(draft, action) {
  var _draft$cols$colIdx;
  var _action$payload4 = action.payload,
    colIdx = _action$payload4.colIdx,
    width = _action$payload4.width;
  draft.cols[colIdx] = (_draft$cols$colIdx = draft.cols[colIdx]) !== null && _draft$cols$colIdx !== void 0 ? _draft$cols$colIdx : {};
  draft.cols[colIdx].width = width;
};
/**
 * 插入列
 *
 * 选中列的前面插入新的列
 *
 * 几种场景：
 * - 新插入的列穿过了合并的单元格
 * - 合并的单元格在新插入的列后面
 * - 合并的单元格在新插入的列前面
 *
 * 要修改的数据：
 * 1. 修改总列数
 * 2. 对穿透的单元格进行合并列+1
 * 3. 对插入列之后的所有单元格列下标+1
 * 4. 修改全部的合并单元格
 *
 * @param draft
 * @param action
 */
var insertCol = function insertCol(draft, action) {
  var _draft$merges7;
  var insertIdx = action.payload;
  // 修改总列数
  draft.cols.len += 1;
  // 修改合并单元格对象
  draft.merges = (_draft$merges7 = draft.merges) === null || _draft$merges7 === void 0 ? void 0 : _draft$merges7.map(function (_ref9) {
    var _ref10 = (0, _slicedToArray2.default)(_ref9, 2),
      _ref10$ = (0, _slicedToArray2.default)(_ref10[0], 2),
      sri = _ref10$[0],
      sci = _ref10$[1],
      _ref10$2 = (0, _slicedToArray2.default)(_ref10[1], 2),
      eri = _ref10$2[0],
      eci = _ref10$2[1];
    if (sci >= insertIdx) {
      // 新插入列之后的合并单元格
      return [[sri, sci + 1], [eri, eci + 1]];
    }
    if (sci < insertIdx && eci >= insertIdx) {
      // 新插入的列穿过合并的单元格
      return [[sri, sci], [eri, eci + 1]];
    }
    return [[sri, sci], [eri, eci]];
  });
  // 处理单元格
  Object.entries(draft.rows).filter(function (item) {
    return item[0] !== 'len';
  }).forEach(function (_ref11) {
    var _ref12 = (0, _slicedToArray2.default)(_ref11, 2),
      rowIdx = _ref12[0],
      row = _ref12[1];
    var cells = row.cells;
    var rIdx = parseInt(rowIdx, 10);
    var newCellValue = {};
    Object.entries(cells !== null && cells !== void 0 ? cells : {}).filter(function (item) {
      return item[0] !== 'height';
    }).forEach(function (_ref13) {
      var _ref14 = (0, _slicedToArray2.default)(_ref13, 2),
        colIdx = _ref14[0],
        cell = _ref14[1];
      var _cell$merge = cell.merge,
        merge = _cell$merge === void 0 ? [0, 0] : _cell$merge;
      var cIdx = parseInt(colIdx, 10);
      if (cIdx + merge[1] < insertIdx) {
        // 没有影响
        newCellValue[cIdx] = cell;
      } else if (merge[1] + cIdx >= insertIdx && cIdx < insertIdx) {
        // 新增的列穿过了合并的单元格
        newCellValue[cIdx] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, cell), {}, {
          merge: [merge[0], merge[1] + 1]
        });
      } else {
        // 否则将影响到的单元格所在列+1
        newCellValue[cIdx + 1] = cell;
      }
    });
    draft.rows[rIdx].cells = newCellValue;
  });
};
/**
 * 删除列，支持选中多列同时删除
 *
 * @param draft
 * @param action
 */
var deleteCol = function deleteCol(draft, action) {
  var _draft$merges8, _draft$merges8$map, _draft$merges8$map$fi;
  var _action$payload5 = action.payload,
    startCol = _action$payload5.startCol,
    endCol = _action$payload5.endCol;
  var removeCols = endCol - startCol + 1;
  // 修改总列数
  draft.cols.len -= removeCols;
  // 修改总的合并单元格数据
  draft.merges = (_draft$merges8 = draft.merges) === null || _draft$merges8 === void 0 ? void 0 : (_draft$merges8$map = _draft$merges8.map(function (_ref15) {
    var _ref16 = (0, _slicedToArray2.default)(_ref15, 2),
      _ref16$ = (0, _slicedToArray2.default)(_ref16[0], 2),
      sri = _ref16$[0],
      sci = _ref16$[1],
      _ref16$2 = (0, _slicedToArray2.default)(_ref16[1], 2),
      eri = _ref16$2[0],
      eci = _ref16$2[1];
    if (eci < startCol) {
      // 合并的单元格在删除的列之前不受影响
      return [[sri, sci], [eri, eci]];
    }
    if (eci >= startCol && eci <= endCol && sci < startCol) {
      // 合并的单元格的末尾行在删除列中
      return [[sri, sci], [eri, startCol - 1]];
    }
    if (sci >= startCol && sci <= endCol && eci > endCol) {
      // 合并的单元格的起始行在删除列中
      return [[sri, startCol], [eri, eci - (sci - startCol + 1)]];
    }
    if (sci >= startCol && eci <= endCol) {
      //  合并的单元格完整在删除列中
      return undefined;
    }
    if (sci < startCol && eci > endCol) {
      // 删除列穿过合并的单元格
      return [[sri, sci], [eri, eci - removeCols]];
    }
    // 合并的单元格在删除的列之后，减去删除的列数
    return [[sri, sci - removeCols], [eri, eci - removeCols]];
  })) === null || _draft$merges8$map === void 0 ? void 0 : (_draft$merges8$map$fi = _draft$merges8$map.filter(Boolean)) === null || _draft$merges8$map$fi === void 0 ? void 0 : _draft$merges8$map$fi.filter(function (_ref17) {
    var _ref18 = (0, _slicedToArray2.default)(_ref17, 2),
      _ref18$ = (0, _slicedToArray2.default)(_ref18[0], 2),
      sri = _ref18$[0],
      sci = _ref18$[1],
      _ref18$2 = (0, _slicedToArray2.default)(_ref18[1], 2),
      eri = _ref18$2[0],
      eci = _ref18$2[1];
    return !(eri - sri === 0 && eci - sci === 0);
  });
  // 处理单元格
  Object.entries(draft.rows).filter(function (item) {
    return item[0] !== 'len';
  }).forEach(function (_ref19) {
    var _ref20 = (0, _slicedToArray2.default)(_ref19, 2),
      rowIdx = _ref20[0],
      row = _ref20[1];
    var cells = row.cells;
    var rIdx = parseInt(rowIdx, 10);
    var newCellValue = {};
    Object.entries(cells !== null && cells !== void 0 ? cells : {}).filter(function (item) {
      return item[0] !== 'height';
    }).forEach(function (_ref21) {
      var _ref22 = (0, _slicedToArray2.default)(_ref21, 2),
        colIdx = _ref22[0],
        cell = _ref22[1];
      var _cell$merge2 = cell.merge,
        merge = _cell$merge2 === void 0 ? [0, 0] : _cell$merge2;
      var cIdx = parseInt(colIdx, 10);
      if (cIdx + merge[1] < startCol) {
        // 单元格在删除列之前
        newCellValue[cIdx] = cell;
      } else if (cIdx + merge[1] >= startCol && cIdx + merge[1] <= endCol && cIdx < startCol) {
        // 合并单元格的末尾列在删除列之中
        newCellValue[cIdx] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, cell), {}, {
          merge: [merge[0], startCol - cIdx - 1]
        });
      } else if (cIdx >= startCol && cIdx <= endCol && cIdx + merge[1] > endCol) {
        // 合并的单元格起始列在删除列之中
        newCellValue[startCol] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, cell), {}, {
          merge: [merge[0], cIdx + merge[1] - endCol - 1],
          value: undefined
        });
      } else if (cIdx >= startCol && cIdx + merge[1] <= endCol) {
        // 单元格在删除列中，直接删除，不做操作
      } else if (cIdx < startCol && cIdx + merge[1] > endCol) {
        // 删除列穿过合并的单元格
        newCellValue[cIdx] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, cell), {}, {
          merge: [merge[0], merge[1] - removeCols]
        });
      } else {
        // 合并的单元格在删除的列之后，减去删除的列数
        newCellValue[cIdx - removeCols] = cell;
      }
    });
    draft.rows[rIdx].cells = newCellValue;
  });
};
/**
 * 单元格拷贝
 *
 * 需要判断复制的单元格是否允许拷贝到目标单元格
 *
 * 简化规则：
 * - 单个单元格的拷贝：
 *   - 如果是普通的单元格直接拷贝内容到目标单元格
 *   - 如果是合并的单元格，目标单元格也是合并的单元格，直接拷贝内容
 *   - 如果是合并的单元格，目标单元格是普通的单元格，需要判定目标单元格旁边的单元格是否满足按照被拷贝的单元格的方式进行单元格合并，不满足不进行拷贝动作
 * - 多个单元格的拷贝：
 *   - 判定源单元格对应的目标区域的单元格是否满足复制条件，及源单元格的覆盖区域移动到对应的目标区域之后，是否有单元格（肯定是合并的单元格）超出目标区域
 *
 * @param draft
 * @param action
 */
var copyCell = function copyCell(draft, action) {
  var _merges$filter$map, _merges$filter, _draft$merges9;
  var _action$payload6 = action.payload,
    _action$payload6$sour = (0, _slicedToArray2.default)(_action$payload6.source, 2),
    _action$payload6$sour2 = (0, _slicedToArray2.default)(_action$payload6$sour[0], 2),
    sri = _action$payload6$sour2[0],
    sci = _action$payload6$sour2[1],
    _action$payload6$sour3 = (0, _slicedToArray2.default)(_action$payload6$sour[1], 2),
    eri = _action$payload6$sour3[0],
    eci = _action$payload6$sour3[1],
    _action$payload6$targ = (0, _slicedToArray2.default)(_action$payload6.target, 2),
    tri = _action$payload6$targ[0],
    tci = _action$payload6$targ[1];
  var merges = draft.merges;
  if (!(0, _checkCellRange.canPastCell)([[sri, sci], [eri, eci]], [tri, tci], draft)) {
    _globalUi.default.message.error('单元格复制目标区域超出边界');
    return;
  }
  //  单个单元格
  if (eri === sri && eci === sci || merges !== null && merges !== void 0 && merges.some(function (_ref23) {
    var _ref24 = (0, _slicedToArray2.default)(_ref23, 2),
      _ref24$ = (0, _slicedToArray2.default)(_ref24[0], 2),
      msri = _ref24$[0],
      msci = _ref24$[1],
      _ref24$2 = (0, _slicedToArray2.default)(_ref24[1], 2),
      meri = _ref24$2[0],
      meci = _ref24$2[1];
    return msri === sri && meri === eri && msci === sci && meci === eci;
  })) {
    var _draft$rows$sri$cells, _draft$rows$sri, _draft$rows$sri$cells2, _draft$rows$sri$cells3, _draft$rows$tri$cells, _draft$rows$tri, _draft$rows$tri$cells2, _draft$rows$tri$cells3;
    var sourceMerge = (_draft$rows$sri$cells = (_draft$rows$sri = draft.rows[sri]) === null || _draft$rows$sri === void 0 ? void 0 : (_draft$rows$sri$cells2 = _draft$rows$sri.cells) === null || _draft$rows$sri$cells2 === void 0 ? void 0 : (_draft$rows$sri$cells3 = _draft$rows$sri$cells2[sci]) === null || _draft$rows$sri$cells3 === void 0 ? void 0 : _draft$rows$sri$cells3.merge) !== null && _draft$rows$sri$cells !== void 0 ? _draft$rows$sri$cells : [0, 0];
    var targetMerge = (_draft$rows$tri$cells = (_draft$rows$tri = draft.rows[tri]) === null || _draft$rows$tri === void 0 ? void 0 : (_draft$rows$tri$cells2 = _draft$rows$tri.cells) === null || _draft$rows$tri$cells2 === void 0 ? void 0 : (_draft$rows$tri$cells3 = _draft$rows$tri$cells2[tci]) === null || _draft$rows$tri$cells3 === void 0 ? void 0 : _draft$rows$tri$cells3.merge) !== null && _draft$rows$tri$cells !== void 0 ? _draft$rows$tri$cells : [0, 0];
    if (
    // 被拷贝的单元格为普通的单元格
    sourceMerge[0] === 0 && sourceMerge[1] === 0 ||
    // 被拷贝的单元格与目标单元格均为合并的单元格
    (sourceMerge[0] !== 0 || sourceMerge[1] !== 0) && (targetMerge[0] !== 0 || targetMerge[1] !== 0)) {
      var _draft$rows$tri2, _draft$rows$tri$cells4, _draft$rows$sri2, _draft$rows$sri2$cell, _draft$rows$sri2$cell2;
      draft.rows[tri] = (_draft$rows$tri2 = draft.rows[tri]) !== null && _draft$rows$tri2 !== void 0 ? _draft$rows$tri2 : {
        cells: {}
      };
      draft.rows[tri].cells[tci] = (_draft$rows$tri$cells4 = draft.rows[tri].cells[tci]) !== null && _draft$rows$tri$cells4 !== void 0 ? _draft$rows$tri$cells4 : {};
      draft.rows[tri].cells[tci].value = (_draft$rows$sri2 = draft.rows[sri]) === null || _draft$rows$sri2 === void 0 ? void 0 : (_draft$rows$sri2$cell = _draft$rows$sri2.cells) === null || _draft$rows$sri2$cell === void 0 ? void 0 : (_draft$rows$sri2$cell2 = _draft$rows$sri2$cell[sci]) === null || _draft$rows$sri2$cell2 === void 0 ? void 0 : _draft$rows$sri2$cell2.value;
      return;
    }
  }
  if (!(0, _checkCellRange.checkCellRange)([tri, tci], [[sri, sci], [eri, eci]], merges)) {
    _globalUi.default.message.error('无法对合并的单元格执行此操作');
    return;
  }
  // 处理merges
  var targetMerges = (_merges$filter$map = merges === null || merges === void 0 ? void 0 : (_merges$filter = merges.filter(function (_ref25) {
    var _ref26 = (0, _slicedToArray2.default)(_ref25, 2),
      _ref26$ = (0, _slicedToArray2.default)(_ref26[0], 2),
      msri = _ref26$[0],
      msci = _ref26$[1],
      _ref26$2 = (0, _slicedToArray2.default)(_ref26[1], 2),
      meri = _ref26$2[0],
      meci = _ref26$2[1];
    return msri >= sri && meri <= eri && msci >= sci && meci <= eci;
  })) === null || _merges$filter === void 0 ? void 0 : _merges$filter.map(function (_ref27) {
    var _ref28 = (0, _slicedToArray2.default)(_ref27, 2),
      _ref28$ = (0, _slicedToArray2.default)(_ref28[0], 2),
      msri = _ref28$[0],
      msci = _ref28$[1],
      _ref28$2 = (0, _slicedToArray2.default)(_ref28[1], 2),
      meri = _ref28$2[0],
      meci = _ref28$2[1];
    return [[msri + tri - sri, msci + tci - sci], [meri + tri - sri, meci + tci - sci]];
  })) !== null && _merges$filter$map !== void 0 ? _merges$filter$map : [];
  draft.merges = merges === null || merges === void 0 ? void 0 : merges.filter(function (_ref29) {
    var _ref30 = (0, _slicedToArray2.default)(_ref29, 2),
      _ref30$ = (0, _slicedToArray2.default)(_ref30[0], 2),
      msri = _ref30$[0],
      msci = _ref30$[1],
      _ref30$2 = (0, _slicedToArray2.default)(_ref30[1], 2),
      meri = _ref30$2[0],
      meci = _ref30$2[1];
    return !(msri >= tri && meri <= tri + eri - sri && msci >= tci && meci <= tci + eci - sci);
  });
  (_draft$merges9 = draft.merges) === null || _draft$merges9 === void 0 ? void 0 : _draft$merges9.push.apply(_draft$merges9, (0, _toConsumableArray2.default)(targetMerges));
  // 处理单元格
  for (var i = sri; i <= eri; i += 1) {
    for (var j = sci; j <= eci; j += 1) {
      var _draft$rows$i3, _draft$rows$i3$cells, _draft$rows3, _draft$rows3$cells;
      if ((_draft$rows$i3 = draft.rows[i]) !== null && _draft$rows$i3 !== void 0 && (_draft$rows$i3$cells = _draft$rows$i3.cells) !== null && _draft$rows$i3$cells !== void 0 && _draft$rows$i3$cells[j]) {
        var _draft$rows2;
        // 源单元格存在数据，直接复制到目标单元格
        draft.rows[tri + i - sri] = (_draft$rows2 = draft.rows[tri + i - sri]) !== null && _draft$rows2 !== void 0 ? _draft$rows2 : {
          cells: {}
        };
        draft.rows[tri + i - sri].cells[tci + j - sci] = draft.rows[i].cells[j];
      } else if ((_draft$rows3 = draft.rows[tri + i - sri]) !== null && _draft$rows3 !== void 0 && (_draft$rows3$cells = _draft$rows3.cells) !== null && _draft$rows3$cells !== void 0 && _draft$rows3$cells[tci + j - sci]) {
        // 如果源位置不存在单元格直接删除
        delete draft.rows[tri + i - sri].cells[tci + j - sci];
      }
    }
  }
};
/**
 * 编辑单元格
 *
 * 单元格编辑有两个地方触发：
 * - 手动编辑单元格时
 * - 拖拽添加表单项时
 *
 * 这里的处理是按照单元格内容是完整可用的可直接替换的处理
 *
 * @param draft
 * @param action
 */
var editCellValue = function editCellValue(draft, action) {
  var _draft$rows$rowIdx2, _draft$rows$rowIdx$ce;
  var _action$payload7 = action.payload,
    _action$payload7$cell = (0, _slicedToArray2.default)(_action$payload7.cellPos, 2),
    rowIdx = _action$payload7$cell[0],
    colIdx = _action$payload7$cell[1],
    value = _action$payload7.value;
  if (rowIdx < 0 || colIdx < 0) return;
  draft.rows[rowIdx] = (_draft$rows$rowIdx2 = draft.rows[rowIdx]) !== null && _draft$rows$rowIdx2 !== void 0 ? _draft$rows$rowIdx2 : {
    cells: {}
  };
  draft.rows[rowIdx].cells = (_draft$rows$rowIdx$ce = draft.rows[rowIdx].cells) !== null && _draft$rows$rowIdx$ce !== void 0 ? _draft$rows$rowIdx$ce : {};
  draft.rows[rowIdx].cells[colIdx] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx]), {}, {
    value: value
  });
};
/**
 * 设置单元格的样式，包括单个单元格和多个单元格
 *
 * 这里的样式主要包括：
 * - 单元格边框线
 * - 水平布局
 * - 垂直布局
 *
 * @param draft
 * @param action
 */
var setCellsStyle = function setCellsStyle(draft, action) {
  var _action$payload8 = action.payload,
    cells = _action$payload8.cells,
    style = _action$payload8.style;
  cells.forEach(function (_ref31) {
    var _draft$rows$rowIdx3, _draft$rows$rowIdx$ce2;
    var _ref32 = (0, _slicedToArray2.default)(_ref31, 2),
      rowIdx = _ref32[0],
      colIdx = _ref32[1];
    draft.rows[rowIdx] = (_draft$rows$rowIdx3 = draft.rows[rowIdx]) !== null && _draft$rows$rowIdx3 !== void 0 ? _draft$rows$rowIdx3 : {
      cells: {}
    };
    draft.rows[rowIdx].cells[colIdx] = (_draft$rows$rowIdx$ce2 = draft.rows[rowIdx].cells[colIdx]) !== null && _draft$rows$rowIdx$ce2 !== void 0 ? _draft$rows$rowIdx$ce2 : {};
    draft.rows[rowIdx].cells[colIdx] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx]), {}, {
      style: (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style), style)
    });
  });
};
/**
 * 设置单元格文本样式，主要包括以下样式
 *
 * - 字体
 * - 字号
 * - 颜色
 * - 背景色
 * - 加粗
 * - 倾斜
 * - 下划线
 *
 * @param draft
 * @param action
 */
var setCellsTextStyle = function setCellsTextStyle(draft, action) {
  var _action$payload9 = action.payload,
    cells = _action$payload9.cells,
    items = _action$payload9.items;
  cells.forEach(function (_ref33, idx) {
    var _draft$rows$rowIdx4;
    var _ref34 = (0, _slicedToArray2.default)(_ref33, 2),
      rowIdx = _ref34[0],
      colIdx = _ref34[1];
    draft.rows[rowIdx] = (_draft$rows$rowIdx4 = draft.rows[rowIdx]) !== null && _draft$rows$rowIdx4 !== void 0 ? _draft$rows$rowIdx4 : {
      cells: {}
    };
    draft.rows[rowIdx].cells[colIdx] = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx]), {}, {
      value: items[idx] // 设置单元格文本样式实际是与slatejs交互变更的是单元格的value
    });
  });
};
/**
 * 单元格剪切
 *
 * @param draft
 * @param action
 * @returns
 */
var cutCell = function cutCell(draft, action) {
  var _merges$filter$map2, _merges$filter2, _draft$merges10;
  var _action$payload10 = action.payload,
    _action$payload10$sou = (0, _slicedToArray2.default)(_action$payload10.source, 2),
    _action$payload10$sou2 = (0, _slicedToArray2.default)(_action$payload10$sou[0], 2),
    sri = _action$payload10$sou2[0],
    sci = _action$payload10$sou2[1],
    _action$payload10$sou3 = (0, _slicedToArray2.default)(_action$payload10$sou[1], 2),
    eri = _action$payload10$sou3[0],
    eci = _action$payload10$sou3[1],
    _action$payload10$tar = (0, _slicedToArray2.default)(_action$payload10.target, 2),
    tri = _action$payload10$tar[0],
    tci = _action$payload10$tar[1];
  var merges = draft.merges;
  if (!(0, _checkCellRange.canPastCell)([[sri, sci], [eri, eci]], [tri, tci], draft)) {
    _globalUi.default.message.error('单元格复制目标区域超出边界');
    return;
  }
  if (!(0, _checkCellRange.checkCellRange)([tri, tci], [[sri, sci], [eri, eci]], merges)) {
    _globalUi.default.message.error('无法对合并的单元格执行此操作');
    return;
  }
  // 处理merges
  var targetMerges = (_merges$filter$map2 = merges === null || merges === void 0 ? void 0 : (_merges$filter2 = merges.filter(function (_ref35) {
    var _ref36 = (0, _slicedToArray2.default)(_ref35, 2),
      _ref36$ = (0, _slicedToArray2.default)(_ref36[0], 2),
      msri = _ref36$[0],
      msci = _ref36$[1],
      _ref36$2 = (0, _slicedToArray2.default)(_ref36[1], 2),
      meri = _ref36$2[0],
      meci = _ref36$2[1];
    return msri >= sri && meri <= eri && msci >= sci && meci <= eci;
  })) === null || _merges$filter2 === void 0 ? void 0 : _merges$filter2.map(function (_ref37) {
    var _ref38 = (0, _slicedToArray2.default)(_ref37, 2),
      _ref38$ = (0, _slicedToArray2.default)(_ref38[0], 2),
      msri = _ref38$[0],
      msci = _ref38$[1],
      _ref38$2 = (0, _slicedToArray2.default)(_ref38[1], 2),
      meri = _ref38$2[0],
      meci = _ref38$2[1];
    return [[msri + tri - sri, msci + tci - sci], [meri + tri - sri, meci + tci - sci]];
  })) !== null && _merges$filter$map2 !== void 0 ? _merges$filter$map2 : [];
  draft.merges = merges === null || merges === void 0 ? void 0 : merges.filter(function (_ref39) {
    var _ref40 = (0, _slicedToArray2.default)(_ref39, 2),
      _ref40$ = (0, _slicedToArray2.default)(_ref40[0], 2),
      msri = _ref40$[0],
      msci = _ref40$[1],
      _ref40$2 = (0, _slicedToArray2.default)(_ref40[1], 2),
      meri = _ref40$2[0],
      meci = _ref40$2[1];
    return (
      // 目标区域的单元格合并信息
      !(msri >= tri && meri <= tri + eri - sri && msci >= tci && meci <= tci + eci - sci) &&
      // 源单元格区域
      !(msri >= sri && meri <= eri && msci >= sci && meci <= eci)
    );
  });
  (_draft$merges10 = draft.merges) === null || _draft$merges10 === void 0 ? void 0 : _draft$merges10.push.apply(_draft$merges10, (0, _toConsumableArray2.default)(targetMerges));
  // 处理单元格
  for (var i = sri; i <= eri; i += 1) {
    for (var j = sci; j <= eci; j += 1) {
      var _draft$rows$i4, _draft$rows$i4$cells, _draft$rows5, _draft$rows5$cells;
      if ((_draft$rows$i4 = draft.rows[i]) !== null && _draft$rows$i4 !== void 0 && (_draft$rows$i4$cells = _draft$rows$i4.cells) !== null && _draft$rows$i4$cells !== void 0 && _draft$rows$i4$cells[j]) {
        var _draft$rows4;
        // 源单元格存在数据，直接复制到目标单元格
        draft.rows[tri + i - sri] = (_draft$rows4 = draft.rows[tri + i - sri]) !== null && _draft$rows4 !== void 0 ? _draft$rows4 : {
          cells: {}
        };
        draft.rows[tri + i - sri].cells[tci + j - sci] = draft.rows[i].cells[j];
        delete draft.rows[i].cells[j];
      } else if ((_draft$rows5 = draft.rows[tri + i - sri]) !== null && _draft$rows5 !== void 0 && (_draft$rows5$cells = _draft$rows5.cells) !== null && _draft$rows5$cells !== void 0 && _draft$rows5$cells[tci + j - sci]) {
        // 如果源位置不存在单元格直接删除
        delete draft.rows[tri + i - sri].cells[tci + j - sci];
      }
    }
  }
};
var ensureCellStyle = function ensureCellStyle(draft, rowIdx, colIdx) {
  var _draft$rows$rowIdx5, _draft$rows$rowIdx$ce3, _draft$rows$rowIdx$ce4;
  draft.rows[rowIdx] = (_draft$rows$rowIdx5 = draft.rows[rowIdx]) !== null && _draft$rows$rowIdx5 !== void 0 ? _draft$rows$rowIdx5 : {
    cells: {}
  };
  draft.rows[rowIdx].cells[colIdx] = (_draft$rows$rowIdx$ce3 = draft.rows[rowIdx].cells[colIdx]) !== null && _draft$rows$rowIdx$ce3 !== void 0 ? _draft$rows$rowIdx$ce3 : {};
  draft.rows[rowIdx].cells[colIdx].style = (_draft$rows$rowIdx$ce4 = draft.rows[rowIdx].cells[colIdx].style) !== null && _draft$rows$rowIdx$ce4 !== void 0 ? _draft$rows$rowIdx$ce4 : {};
};
var getCellsByBorderType = function getCellsByBorderType(draft, range, type) {
  var cells = (0, _getAllSelectedCells.default)(range, draft.merges).filter(function (_ref41) {
    var _draft$merges12, _draft$merges12$find, _draft$merges12$find$;
    var _ref42 = (0, _slicedToArray2.default)(_ref41, 2),
      rowIdx = _ref42[0],
      colIdx = _ref42[1];
    switch (type) {
      case _constants.BorderType.BORDER_LEFT:
        return colIdx === range[0][1];
      case _constants.BorderType.BORDER_TOP:
        return rowIdx === range[0][0];
      case _constants.BorderType.BORDER_RIGHT:
        {
          var _draft$merges11, _draft$merges11$find, _draft$merges11$find$;
          return colIdx === range[1][1] || ((_draft$merges11 = draft.merges) === null || _draft$merges11 === void 0 ? void 0 : (_draft$merges11$find = _draft$merges11.find(function (_ref43) {
            var _ref44 = (0, _slicedToArray2.default)(_ref43, 2),
              _ref44$ = (0, _slicedToArray2.default)(_ref44[0], 2),
              msri = _ref44$[0],
              msci = _ref44$[1],
              _ref44$2 = (0, _slicedToArray2.default)(_ref44[1], 2),
              meri = _ref44$2[0],
              meci = _ref44$2[1];
            return rowIdx >= msri && rowIdx <= meri && colIdx >= msci && colIdx <= meci;
          })) === null || _draft$merges11$find === void 0 ? void 0 : (_draft$merges11$find$ = _draft$merges11$find[1]) === null || _draft$merges11$find$ === void 0 ? void 0 : _draft$merges11$find$[1]) === range[1][1];
        }
      case _constants.BorderType.BORDER_BOTTOM:
        return rowIdx === range[1][0] || ((_draft$merges12 = draft.merges) === null || _draft$merges12 === void 0 ? void 0 : (_draft$merges12$find = _draft$merges12.find(function (_ref45) {
          var _ref46 = (0, _slicedToArray2.default)(_ref45, 2),
            _ref46$ = (0, _slicedToArray2.default)(_ref46[0], 2),
            msri = _ref46$[0],
            msci = _ref46$[1],
            _ref46$2 = (0, _slicedToArray2.default)(_ref46[1], 2),
            meri = _ref46$2[0],
            meci = _ref46$2[1];
          return rowIdx >= msri && rowIdx <= meri && colIdx >= msci && colIdx <= meci;
        })) === null || _draft$merges12$find === void 0 ? void 0 : (_draft$merges12$find$ = _draft$merges12$find[1]) === null || _draft$merges12$find$ === void 0 ? void 0 : _draft$merges12$find$[0]) === range[1][0];
      default:
        return true;
    }
  });
  return cells;
};
/**
 * 设置边框 上下左右 全部和取消
 *
 * @param draft
 * @param range
 * @param style
 * @param type
 */
var setCellsByBorderPosType = function setCellsByBorderPosType(draft, range, style, type) {
  var border;
  switch (type) {
    case _constants.BorderType.BORDER_LEFT:
      border = {
        borderLeft: style
      };
      break;
    case _constants.BorderType.BORDER_RIGHT:
      border = {
        borderRight: style
      };
      break;
    case _constants.BorderType.BORDER_TOP:
      border = {
        borderTop: style
      };
      break;
    case _constants.BorderType.BORDER_BOTTOM:
      border = {
        borderBottom: style
      };
      break;
    case _constants.BorderType.BORDER_ALL:
      border = {
        borderLeft: style,
        borderRight: style,
        borderTop: style,
        borderBottom: style
      };
      break;
    default:
      break;
  }
  var cells = getCellsByBorderType(draft, range, type);
  cells.forEach(function (_ref47) {
    var _ref48 = (0, _slicedToArray2.default)(_ref47, 2),
      rowIdx = _ref48[0],
      colIdx = _ref48[1];
    ensureCellStyle(draft, rowIdx, colIdx);
    if (border) {
      draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), border);
    } else {
      delete draft.rows[rowIdx].cells[colIdx].style.border;
    }
  });
};
/**
 * 水平或垂直边框
 *
 * @param draft
 * @param range
 * @param type
 * @param style
 */
var setBorderHorizontalOrVerital = function setBorderHorizontalOrVerital(draft, range, type, style) {
  var cells = (0, _getAllSelectedCells.default)(range, draft.merges);
  cells.forEach(function (_ref49) {
    var _ref50 = (0, _slicedToArray2.default)(_ref49, 2),
      rowIdx = _ref50[0],
      colIdx = _ref50[1];
    if (type === _constants.BorderType.BORDER_HORIZONTAL && rowIdx !== range[0][0] || type === _constants.BorderType.BORDER_VERTICAL && colIdx !== range[0][1]) {
      ensureCellStyle(draft, rowIdx, colIdx);
      draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), {}, (0, _defineProperty2.default)({}, type === _constants.BorderType.BORDER_HORIZONTAL ? 'borderTop' : 'borderLeft', style));
    }
  });
};
/**
 * 外边框
 *
 * @param draft
 * @param range
 * @param style
 */
var setBorderOuter = function setBorderOuter(draft, range, style) {
  var cells = (0, _getAllSelectedCells.default)(range, draft.merges);
  cells.forEach(function (_ref51) {
    var _draft$merges13, _draft$merges13$find, _draft$merges13$find$, _draft$merges14, _draft$merges14$find, _draft$merges14$find$;
    var _ref52 = (0, _slicedToArray2.default)(_ref51, 2),
      rowIdx = _ref52[0],
      colIdx = _ref52[1];
    ensureCellStyle(draft, rowIdx, colIdx);
    // 最上行
    if (rowIdx === range[0][0]) {
      draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), {}, {
        borderTop: style
      });
    }
    // 最左列
    if (colIdx === range[0][1]) {
      draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), {}, {
        borderLeft: style
      });
    }
    // 最右列
    if (colIdx === range[1][1] || ((_draft$merges13 = draft.merges) === null || _draft$merges13 === void 0 ? void 0 : (_draft$merges13$find = _draft$merges13.find(function (_ref53) {
      var _ref54 = (0, _slicedToArray2.default)(_ref53, 2),
        _ref54$ = (0, _slicedToArray2.default)(_ref54[0], 2),
        msri = _ref54$[0],
        msci = _ref54$[1],
        _ref54$2 = (0, _slicedToArray2.default)(_ref54[1], 2),
        meri = _ref54$2[0],
        meci = _ref54$2[1];
      return rowIdx >= msri && rowIdx <= meri && colIdx >= msci && colIdx <= meci;
    })) === null || _draft$merges13$find === void 0 ? void 0 : (_draft$merges13$find$ = _draft$merges13$find[1]) === null || _draft$merges13$find$ === void 0 ? void 0 : _draft$merges13$find$[1]) === range[1][1]) {
      draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), {}, {
        borderRight: style
      });
    }
    // 最下行
    if (rowIdx === range[1][0] || ((_draft$merges14 = draft.merges) === null || _draft$merges14 === void 0 ? void 0 : (_draft$merges14$find = _draft$merges14.find(function (_ref55) {
      var _ref56 = (0, _slicedToArray2.default)(_ref55, 2),
        _ref56$ = (0, _slicedToArray2.default)(_ref56[0], 2),
        msri = _ref56$[0],
        msci = _ref56$[1],
        _ref56$2 = (0, _slicedToArray2.default)(_ref56[1], 2),
        meri = _ref56$2[0],
        meci = _ref56$2[1];
      return rowIdx >= msri && rowIdx <= meri && colIdx >= msci && colIdx <= meci;
    })) === null || _draft$merges14$find === void 0 ? void 0 : (_draft$merges14$find$ = _draft$merges14$find[1]) === null || _draft$merges14$find$ === void 0 ? void 0 : _draft$merges14$find$[0]) === range[1][0]) {
      draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), {}, {
        borderBottom: style
      });
    }
  });
};
/**
 * 内边框
 *
 * @param draft
 * @param range
 * @param style
 */
var setBorderInner = function setBorderInner(draft, range, style) {
  var cells = (0, _getAllSelectedCells.default)(range, draft.merges);
  cells.forEach(function (_ref57) {
    var _draft$merges15, _draft$merges15$find, _draft$merges15$find$, _draft$merges16, _draft$merges16$find, _draft$merges16$find$;
    var _ref58 = (0, _slicedToArray2.default)(_ref57, 2),
      rowIdx = _ref58[0],
      colIdx = _ref58[1];
    ensureCellStyle(draft, rowIdx, colIdx);
    var border = {
      borderLeft: style,
      borderTop: style,
      borderBottom: style,
      borderRight: style
    };
    // 最上行
    if (rowIdx === range[0][0]) {
      delete border.borderTop;
    }
    // 最左列
    if (colIdx === range[0][1]) {
      delete border.borderLeft;
    }
    // 最右列
    if (colIdx === range[1][1] || ((_draft$merges15 = draft.merges) === null || _draft$merges15 === void 0 ? void 0 : (_draft$merges15$find = _draft$merges15.find(function (_ref59) {
      var _ref60 = (0, _slicedToArray2.default)(_ref59, 2),
        _ref60$ = (0, _slicedToArray2.default)(_ref60[0], 2),
        msri = _ref60$[0],
        msci = _ref60$[1],
        _ref60$2 = (0, _slicedToArray2.default)(_ref60[1], 2),
        meri = _ref60$2[0],
        meci = _ref60$2[1];
      return rowIdx >= msri && rowIdx <= meri && colIdx >= msci && colIdx <= meci;
    })) === null || _draft$merges15$find === void 0 ? void 0 : (_draft$merges15$find$ = _draft$merges15$find[1]) === null || _draft$merges15$find$ === void 0 ? void 0 : _draft$merges15$find$[1]) === range[1][1]) {
      delete border.borderRight;
    }
    // 最下行
    if (rowIdx === range[1][0] || ((_draft$merges16 = draft.merges) === null || _draft$merges16 === void 0 ? void 0 : (_draft$merges16$find = _draft$merges16.find(function (_ref61) {
      var _ref62 = (0, _slicedToArray2.default)(_ref61, 2),
        _ref62$ = (0, _slicedToArray2.default)(_ref62[0], 2),
        msri = _ref62$[0],
        msci = _ref62$[1],
        _ref62$2 = (0, _slicedToArray2.default)(_ref62[1], 2),
        meri = _ref62$2[0],
        meci = _ref62$2[1];
      return rowIdx >= msri && rowIdx <= meri && colIdx >= msci && colIdx <= meci;
    })) === null || _draft$merges16$find === void 0 ? void 0 : (_draft$merges16$find$ = _draft$merges16$find[1]) === null || _draft$merges16$find$ === void 0 ? void 0 : _draft$merges16$find$[0]) === range[1][0]) {
      delete border.borderBottom;
    }
    draft.rows[rowIdx].cells[colIdx].style.border = (0, _objectSpread3.default)((0, _objectSpread3.default)({}, draft.rows[rowIdx].cells[colIdx].style.border), border);
  });
};
/**
 * 设置单元格边框
 *
 * @param draft
 * @param action
 */
var setCellsBorderStyle = function setCellsBorderStyle(draft, action) {
  var _action$payload11 = action.payload,
    type = _action$payload11.type,
    style = _action$payload11.style,
    range = _action$payload11.range;
  if (!range) {
    return;
  }
  switch (type) {
    case _constants.BorderType.BORDER_ALL:
    case _constants.BorderType.BORDER_LEFT:
    case _constants.BorderType.BORDER_RIGHT:
    case _constants.BorderType.BORDER_TOP:
    case _constants.BorderType.BORDER_BOTTOM:
    case _constants.BorderType.BORDER_CLEAR:
      setCellsByBorderPosType(draft, range, style, type);
      break;
    case _constants.BorderType.BORDER_HORIZONTAL:
    case _constants.BorderType.BORDER_VERTICAL:
      setBorderHorizontalOrVerital(draft, range, type, style);
      break;
    case _constants.BorderType.BORDER_OUTER:
      setBorderOuter(draft, range, style);
      break;
    case _constants.BorderType.BORDER_INNER:
      setBorderInner(draft, range, style);
      break;
    default:
      break;
  }
};
var replaceConfig = function replaceConfig(draft, action) {
  var _action$payload12 = action.payload,
    cols = _action$payload12.cols,
    rows = _action$payload12.rows,
    merges = _action$payload12.merges,
    config = _action$payload12.config;
  draft.cols = cols;
  draft.rows = rows;
  draft.merges = merges;
  draft.config = config;
  draft.editingCell = undefined;
};
var reducer = /*#__PURE__*/(0, _immer.produce)(function () {
  var draft = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case _types2.ActionType.MERGE_CELLS:
      mergeCells(draft, action);
      break;
    case _types2.ActionType.CHANGE_ROW_HEIGHT:
      changeRowHeight(draft, action);
      break;
    case _types2.ActionType.INSERT_ROW:
      insertRow(draft, action);
      break;
    case _types2.ActionType.DELETE_ROW:
      deleteRow(draft, action);
      break;
    case _types2.ActionType.CHANGE_COL_WIDTH:
      changeColWidth(draft, action);
      break;
    case _types2.ActionType.INSERT_COL:
      insertCol(draft, action);
      break;
    case _types2.ActionType.DELETE_COL:
      deleteCol(draft, action);
      break;
    case _types2.ActionType.COPY_CELL:
      copyCell(draft, action);
      break;
    case _types2.ActionType.CUT_CELL:
      cutCell(draft, action);
      break;
    case _types2.ActionType.EDIT_CELL_VALUE:
      editCellValue(draft, action);
      break;
    case _types2.ActionType.SET_CELLS_STYLE:
      setCellsStyle(draft, action);
      break;
    case _types2.ActionType.SET_CELLS_TEXT_STYLE:
      setCellsTextStyle(draft, action);
      break;
    case _types2.ActionType.SET_CELLS_BORDER_STYLE:
      setCellsBorderStyle(draft, action);
      break;
    case _types2.ActionType.SET_PRINT_CONFIG:
      draft.config = action.payload;
      break;
    case _types2.ActionType.SET_EDITING_CELL:
      draft.editingCell = action.payload;
      break;
    case _types2.ActionType.REPLACE_CONFIG:
      replaceConfig(draft, action);
      break;
    default:
      break;
  }
});
var _default = reducer;
exports.default = _default;